MODULE Setup;
(* Generated by m3bundle; see its manpage. *)

IMPORT Bundle, BundleRep, Text;
IMPORT Thread, Wr, TextWr;

TYPE T = Bundle.T OBJECT OVERRIDES
           get      := LookUp;
           getNames := GetNames;
         END;

TYPE Texts = REF ARRAY OF TEXT;

VAR
  bundle: T     := NIL;
  names : Texts := NIL;

PROCEDURE Get(): Bundle.T =
  BEGIN
    IF (bundle = NIL) THEN bundle := NEW (T) END;
    RETURN bundle;
  END Get;

PROCEDURE GetNames (<*UNUSED*> self: T): Texts = 
  BEGIN
    IF names = NIL THEN
      names := NEW (Texts, NUMBER (Names));
      names^ := Names;
    END;
    RETURN names;
  END GetNames;

PROCEDURE LookUp (<*UNUSED*> self: T;  element: TEXT): TEXT = 
  BEGIN
    FOR i := 0 TO LAST (Names)-1 DO
      IF Text.Equal (Names[i], element) THEN
        IF Elements[i] = NIL THEN Elements[i] := GetElt (i) END;
        RETURN Elements[i];
      END;
    END;
    RETURN NIL;
  END LookUp;

CONST Names = ARRAY [0..1] OF TEXT {
  "config",
  NIL
};

VAR Elements := ARRAY [0..1] OF TEXT {
  NIL (* E0 .. E0_7 *),
  NIL
};

PROCEDURE GetElt (n: INTEGER): TEXT =
  <*FATAL Thread.Alerted, Wr.Failure *>
  VAR wr := TextWr.New ();
  BEGIN
    CASE n OF
    | 0 =>
        Wr.PutText (wr, E0);
        Wr.PutText (wr, E0_0);
        Wr.PutText (wr, E0_1);
        Wr.PutText (wr, E0_2);
        Wr.PutText (wr, E0_3);
        Wr.PutText (wr, E0_4);
        Wr.PutText (wr, E0_5);
        Wr.PutText (wr, E0_6);
        Wr.PutText (wr, E0_7);
    ELSE (*skip*)
    END;
    RETURN TextWr.ToText (wr);
  END GetElt;

CONST E0 = 
   "% Copyright 1996 Critical Mass, Inc. All rights reserved.\n% \n% Standa"
 & "rd configuration file for LINUX with ELF object files\n%\n\n%----------"
 & "---------------------------------------- compilation environment ---\n\n"
 & "%M3_PROFILING = TRUE  % set by cm3 since 5.1.2 (option -profile)\n%M3_P"
 & "ROFILING = FALSE\n\nreadonly TARGET       = \"LINUXLIBC6\"      % code "
 & "generation target\nif M3_PROFILING \n  readonly BUILD_DIR  = TARGET & \""
 & "p\"      % code generation target\nelse\n  readonly BUILD_DIR  = TARGET"
 & "            % directory for results\nend\nreadonly OS_TYPE      = \"POS"
 & "IX\"           % { \"WIN32\" or \"POSIX\" }\nreadonly WORD_SIZE    = \""
 & "32BITS\"          % { \"32BITS\" or \"64BITS\" }\nreadonly GNU_PLATFORM"
 & " = \"i486--linuxelf\"  % \"cpu-vendor-os\" string for GNU\n%readonly IN"
 & "STALL_KEY  = BEGIN_CONFIG\n%  \"What is your installation key?\"\n%    "
 & "14 %-- user specified key\n%END_CONFIG\n\nreadonly NAMING_CONVENTIONS ="
 & " \"0\"\n%                                        object files       lib"
 & "raries\n%  0=Unix                          =>  .o   .io    .mo       li"
 & "bXX.a\n%  1=Unix with a grumpy C compiler =>  .o   _i.o   _m.o      lib"
 & "XX.a\n%  2=Windows NT or Windows 95      =>  .obj .io    .mo       XX.l"
 & "ib\n%\n\n%-------------------------------------------------- default co"
 & "mpile options ---\n% \"set_config_options\" is called before starting t"
 & "he compilation.  It should\n% be used to provide system-wide default op"
 & "tions.\n\nproc set_config_options () is\n  m3_option (\"-why\")   %-- p"
 & "roduce a listing that explains what\'s happening and why\n  m3_debug (T"
 & "RUE)      %-- produce object code with debugging symbols\n  M3_OPTIONS "
 & "+= \"-w1\"  %-- produce \"level 1\" warnings\nend\n\n%-----------------"
 & "---------------------------------------- Reactor defaults ---\n% The fi"
 & "rst time a user runs Reactor, it will configure itself to use\n% the ex"
 & "ecutables defined below.\n\n%INITIAL_REACTOR_BROWSER = BEGIN_CONFIG\n% "
 & " \"What should be the default World-Wide Web browser for new Reactor us"
 & "ers?\"\n%     0  \"netscape\"\n%     6 \"/usr/local/bin\"           \"n"
 & "etscape\"\n%     6 \"/usr/loca";

CONST E0_0 = 
   "l/netscape/bin\"  \"netscape\"\n%     6 \"/usr/local/netscape/bin\"  \""
 & "netscape-3\"\n%     6 \"/usr/local/netscape/bin\"  \"netscape-2\"\n%   "
 & "  6 \"/usr/local/netscape\"      \"netscape\"\n%     6 \"/usr/local/mos"
 & "aic\"        \"mosaic\"\n%     6 \"/usr/local/moasic\"        \"Xmosaic"
 & "\"\n%END_CONFIG\n% A World-Wide Web browser.  Reactor passes it an init"
 & "ial URL\n% its first command-line argument.\n\nINITIAL_REACTOR_EDITOR ="
 & " BEGIN_CONFIG\n  \"What should be the default text editor for new React"
 & "or users?\"\n    10 \"EDITOR\"\n     0 \"emacsclient\"\n     0 \"emacs\""
 & "\n     0 \"vi\"\n     0 \"textedit\"\n     0 \"xedit\"\n     6 \"/usr/l"
 & "ocal/emacs/bin\" \"emacsclient\"\n     6 \"/usr/local/bin\"       \"ema"
 & "csclient\"\n     6 \"/usr/local/emacs/bin\" \"emacs\"\n     6 \"/usr/lo"
 & "cal/bin\"       \"emacs\"\n     6 \"/usr/bin\"             \"vi\"\n    "
 & " 6 \"/usr/local/X11R5/bin\" \"xedit\"\n     6 \"/usr/openwin/bin\"     "
 & "\"textedit\"\n     6 \"/usr/openwin/bin\"     \"xedit\"\n     6 \"/usr/"
 & "X11/bin\"         \"xedit\"\n     6 \"/usr/bin/X11\"         \"xedit\"\n"
 & "END_CONFIG\n% A text editor.  Reactor passes it \"<file> +<line>\" on t"
 & "he\n% command-line when it wants to edit <file> initially positioned\n%"
 & " at <line>.\n\n%-------------------------------------------------------"
 & "------ export paths ---\n% During the installation, destination directo"
 & "ries that do not exists \n% will be created. You need the necessary per"
 & "missions to do so; otherwise,\n% the installation will fail, but can be"
 & " restarted after you have \n% fixed the permissions.\n\nINSTALL_ROOT = "
 & "BEGIN_CONFIG\n  \"Where should Reactor be installed?\"\n    7 %-- user "
 & "specified install root\nEND_CONFIG\n\nBIN_INSTALL   = INSTALL_ROOT & \""
 & "/bin\"        % executables\nif M3_PROFILING \n  LIB_INSTALL   = INSTAL"
 & "L_ROOT & \"/libp\"       % libraries\nelse\n  LIB_INSTALL   = INSTALL_R"
 & "OOT & \"/lib\"        % libraries\nend\nPKG_INSTALL   = INSTALL_ROOT & "
 & "\"/pkg\"        % packages\nDOC_INSTALL   = INSTALL_ROOT & \"/doc\"    "
 & "    % documents\nEMACS_INSTALL = INSTALL_ROOT & \"/elisp\"      % emacs"
 & " lisp code\nMAN_INSTALL   = INSTALL_ROOT & \"/man\"        % man pages\n"
 & "HTML_INSTALL  = ";

CONST E0_1 = 
   "INSTALL_ROOT & \"/www\"        % public hypertext\n\n% On some systems "
 & "(e.g. AFS) you must install public files in a different\n% place from w"
 & "here you use them.  If that is the case for your system,\n% specify the"
 & " \"use\" location here, otherwise leave them alone.\n%\nUSE_ROOT  = INS"
 & "TALL_ROOT\nBIN_USE   = BIN_INSTALL       % executables\nLIB_USE   = LIB"
 & "_INSTALL       % libraries\nPKG_USE   = PKG_INSTALL       % packages\n\n"
 & "readonly INSTALL_IMPLS = TRUE\n% TRUE\n%    => save all source files du"
 & "ring the install\n%    => makes debugging easier and browsing more frui"
 & "tful\n% FALSE\n%    => save only the exported interfaces and templates "
 & "\n%    => makes the installed system slightly smaller.\n\n%------------"
 & "------------------------------------ external system libraries ---\n% S"
 & "YSTEM_LIBS provides a mapping from Modula-3 names for the common\n% ext"
 & "ernal libraries to site-dependent information about how they\n% are acc"
 & "essed.  If SYSTEM_LIBS{x} is defined it should be a list\n% of linker a"
 & "rguments that are used when linking against that library.\n% If SYSTEM_"
 & "LIBS{x} is not defined, the Modula-3 system will assume\n% that the lib"
 & "rary is not available.\n\nSYSTEM_LIBS = {\n  \"LIBC\"       : [ \"-Xlin"
 & "ker\", \"-Bdynamic\", \"-L/usr/lib\", \"-lm\", \"-L/usr/lib\", \"-lpthr"
 & "ead\" ],\n%-- not on most Linux platforms\n% \"LEX-YACC\"   : [ \"-Xlin"
 & "ker\", \"-Bdynamic\", BEGIN_CONFIG\n%                    \"Where are th"
 & "e lex/yacc libraries?\"\n%                      11 \"libl.a\"\n%       "
 & "               12 \"/usr/lib\"\n%                      12 \"/usr/local/"
 & "lib\"\n%                      12 \"/usr/local/gnu/lib\"\n%             "
 & "         13 \"/usr/lib\"\n%                  END_CONFIG, \"-ll\" ],\n  "
 & "\"FLEX-BISON\" : [ \"-Xlinker\", \"-Bdynamic\", BEGIN_CONFIG\n         "
 & "            \"Where are the flex/bison libraries?\"\n                  "
 & "     11 \"libfl.a\"\n                       12 \"/usr/lib\"\n          "
 & "             12 \"/usr/local/lib\"\n                       12 \"/usr/lo"
 & "cal/gnu/lib\"\n                       13 \"/usr/lib\"\n                "
 & "   END_CONFIG, \"-lfl\" ],\n  \"POSTGRES95\" :";

CONST E0_2 = 
   " [ \"-Xlinker\", \"-Bdynamic\", BEGIN_CONFIG\n                     \"Wh"
 & "ere are the Postgres95 libraries?\"\n                       11 \"libpq."
 & "so\"\n                       12 \"/usr/local/postgres95/lib\"\n        "
 & "               12 \"/usr/local/lib\"\n                       12 \"/usr/"
 & "lib\"\n                       13 \"/usr/lib\"\n                   END_C"
 & "ONFIG, \"-lpq\" ],\n  \"OPENGL\"     : [ \"-Xlinker\", \"-Bdynamic\", B"
 & "EGIN_CONFIG\n                     \"Where are the OpenGL libraries?\"\n"
 & "                       11 \"libGLU.so\"\n                       11 \"li"
 & "bGL.so\"\n                       12 \"/usr/lib\"\n                     "
 & "  12 \"/usr/local/lib\"\n                       12 \"/usr/local/gnu/lib"
 & "\"\n                       13 \"/usr/lib\"\n                   END_CONF"
 & "IG, \"-lGLU\", \"-lGL\", \"-lXext\" ],\n  \"ODBC\"       : [ \"-Xlinker"
 & "\", \"-Bdynamic\", BEGIN_CONFIG\n                     \"Where are the O"
 & "DBC libraries?\"\n                       11 \"libodbc.so\"\n           "
 & "            12 \"/usr/local/lib\"\n                       12 \"/usr/lib"
 & "\"\n                       12 \"/usr/local/pgsql/lib\"\n               "
 & "        12 \"/usr/local/postgres95/lib\"\n                       13 \"/"
 & "usr/local/lib\"\n                   END_CONFIG, \"-lodbc\" ],\n  \"MOTI"
 & "F\"      : [ \"-Xlinker\", \"-Bdynamic\", BEGIN_CONFIG\n               "
 & "      \"Where are the Motif libraries?\"\n                       11 \"l"
 & "ibXm.so\"\n                       12 \"/usr/X11/lib\"\n                "
 & "       12 \"/usr/X11R6/lib\"\n                       12 \"/usr/lib\"\n "
 & "                      12 \"/usr/local/lib\"\n                       12 "
 & "\"/usr/local/gnu/lib\"\n                       13 \"/usr/X11/lib\"\n   "
 & "                    13 \"/usr/X11R6/lib\"\n                       13 \""
 & "/usr/lib\"\n                   END_CONFIG, \"-lXm\" ],\n  \"X11\"      "
 & "  : [ \"-Xlinker\", \"-Bdynamic\", BEGIN_CONFIG\n                     \""
 & "Where are the X11 libraries?\"\n                       11 \"libXaw.so\""
 & "\n                       11 \"libXmu.so\"\n                       11 \""
 & "libXext.so\"\n                       11 \"libXt.so\"\n                 "
 & "      11 \"libSM.so\"\n   ";

CONST E0_3 = 
   "                    11 \"libICE.so\"\n                       11 \"libX1"
 & "1.so\"\n                       12 \"/usr/X11/lib\"\n                   "
 & "    12 \"/usr/X11R6/lib\"\n                       12 \"/usr/lib\"\n    "
 & "                   12 \"/usr/local/lib\"\n                       12 \"/"
 & "usr/local/gnu/lib\"\n                       13 \"/usr/X11/lib\"\n      "
 & "                 13 \"/usr/X11R6/lib\"\n                       13 \"/us"
 & "r/lib\"\n                   END_CONFIG, \"-lXaw\", \"-lXmu\", \"-lXext\""
 & ",\n                        \"-lXt\", \"-lSM\", \"-lICE\", \"-lX11\" ],\n"
 & "  \"TCP\"        : [ ]\n}\n\n% SYSTEM_LIBORDER defines the order in whi"
 & "ch SYSTEM_LIBS should be\n% scanned by the linker.\n\nSYSTEM_LIBORDER ="
 & " [ \"OPENGL\", \"DECPEX\", \"MOTIF\", \"X11\", \"TCP\", \"ODBC\",\n    "
 & "                \"POSTGRES95\", \"FLEX-BISON\", \"LEX-YACC\", \"LIBC\" "
 & "]\n\n%---------------------------------------------------------- system"
 & " programs ---\n\nreadonly SYSTEM_CC  = BEGIN_CONFIG\n  \"Where is your "
 & "C compiler?\"\n    0 \"gcc\"\n    6 \"/bin\"           \"gcc\"\n    6 \""
 & "/usr/bin\"       \"gcc\"\n    6 \"/usr/local\"     \"gcc\"\n    6 \"/us"
 & "r/local/bin\" \"gcc\"\n    6 \"/usr/local/gnu\" \"gcc\"\n    0 \"cc\"\n"
 & "    6 \"/bin\"           \"cc\"\n    6 \"/usr/bin\"       \"cc\"\n    6"
 & " \"/usr/local\"     \"cc\"\n    6 \"/usr/local/bin\" \"cc\"\n    6 \"/u"
 & "sr/local/gnu\" \"cc\"\nEND_CONFIG % C compiler\nreadonly SYSTEM_AR  = B"
 & "EGIN_CONFIG\n  \"Where is your library archiver?\"\n    0 \"ar\"\n    6"
 & " \"/usr/bin\"       \"ar\"\n    6 \"/bin\"           \"ar\"\n    6 \"/u"
 & "sr/local\"     \"ar\"\n    6 \"/usr/local/bin\" \"ar\"\n    6 \"/usr/lo"
 & "cal/gnu\" \"ar\"\nEND_CONFIG % Archiver\nreadonly SYSTEM_ASM = BEGIN_CO"
 & "NFIG\n  \"Where is your assembler?\"\n    0 \"as\"\n    6 \"/usr/bin\" "
 & "      \"as\"\n    6 \"/bin\"           \"as\"\n    6 \"/usr/local\"    "
 & " \"as\"\n    6 \"/usr/local/bin\" \"as\"\n    6 \"/usr/local/gnu\" \"as"
 & "\"\nEND_CONFIG % Assembler\n\n%----------------------------------------"
 & "----------------- Modula-3 backend ---\n% For platforms without an inte"
 & "grated backend, \"m3_backend\" is called to\n% translate Modula-3 inter"
 & "mediate code to object code.\n\nreadonly m3back = \"@\" & BIN_USE & \"/"
 & "cm3cg\"\n\nproc";

CONST E0_4 = 
   " m3_backend (source, object, optimize, debug) is\n  local args = [ \"-q"
 & "uiet\", source, \"-o\", object, \"-fPIC\", \"-m32\", \"-fno-reorder-blo"
 & "cks\" ]\n  if optimize  args += \"-O3\"  end\n  if debug     args += \""
 & "-gstabs+\"  end\n  if M3_PROFILING args += \"-p\" end\n  return try_exe"
 & "c (m3back, args)\nend\n\nM3_BACKEND_MODE = \"3\"\n% -- defines how the "
 & "frontend, backend, and assembler interact\n%  \"0\"  -- don\'t call m3_"
 & "backend, M3CG produces object code\n%  \"1\"  -- don\'t call m3_backend"
 & ", M3CG produces assembly code\n%  \"2\"  -- call m3_backend, it produce"
 & "s object code\n%  \"3\"  -- call m3_backend, it produces assembly code\n"
 & "\n%--------------------------------------------------------------- C co"
 & "mpiler ---\n% \"compile_c\" is called to compile C source files.  Note "
 & "that this function\n% is only called if your program or library explici"
 & "tly includes C source\n% code, the system distributed by Critical Mass "
 & "does not.\n\nproc compile_c (source, object, options, optimize, debug) "
 & "is\n  local args = [ \"-m32\", \"-fPIC\", options ]\n  if optimize  arg"
 & "s += \"-O\"  end\n  if debug     args += \"-gstabs+\"  end\n  if M3_PRO"
 & "FILING args += \"-pg\" end\n  return try_exec (\"@\" & SYSTEM_CC, args,"
 & " \"-c\", source)\nend\n\n%---------------------------------------------"
 & "------------------- assembler ---\n% \"assemble\" is called to assemble"
 & " .s or .asm files.  Note that this function\n% is only called if your p"
 & "rogram or library explicitly includes assembly source\n% code, the syst"
 & "em distributed by Critical Mass does not.\n\nproc assemble (source, obj"
 & "ect) is\n  return try_exec (\"@\" & SYSTEM_ASM, \"--32\", source, \"-o\""
 & ", object)\nend\n\n%----------------------------------------------------"
 & "----- library creation ---\n% \"make_lib\" is called to combine a colle"
 & "ction of object modules into\n% a library.\n\nproc make_lib (lib, optio"
 & "ns, objects, imported_libs, shared) is\n  local ret_code = 0\n  local l"
 & "ib_a    = format (\"lib%s.a\", lib)\n  local lib_so   = format (\"lib%s"
 & ".so\", lib)\n  local lib_sox  = format (\"lib%s.so.5\", lib)\n\n  % fir"
 & "st, build the non-shared library\n  ret_code = ";

CONST E0_5 = 
   "try_exec (\"@/usr/bin/ar\", \"crus\", lib_a, objects)\n  if not equal ("
 & "ret_code, 0) return ret_code end\n\n  if shared\n    % build the shared"
 & " library\n    if M3_PROFILING \n      ret_code = try_exec (\"@\" & SYST"
 & "EM_CC, \"-pg -shared -m32 \" &\n                           \"-Wl,-sonam"
 & "e,\" & lib_sox,\n                           \"-o\", lib_sox, objects)\n"
 & "    else\n      ret_code = try_exec (\"@\" & SYSTEM_CC, \"-shared -m32 "
 & "\" &\n                           \"-Wl,-soname,\" & lib_sox,\n         "
 & "                  \"-o\", lib_sox, objects)\n    end\n    if not equal "
 & "(ret_code, 0) return ret_code end\n\n    % create the version aliases\n"
 & "    link_file(lib_sox, lib_so)\n\n    % finally, make sure the shared l"
 & "ibrary stuff gets installed properly\n    install_derived (lib_sox)\n  "
 & "  install_derived_link (lib_sox, lib_so)\n    install_link_to_derived ("
 & "lib_sox, LIB_INSTALL)\n    install_link_to_derived (lib_so, LIB_INSTALL"
 & ")\n  else\n    delete_file (lib_so)\n    delete_file (lib_sox)\n  end\n"
 & "\n  return 0\nend\n\n%-------------------------------------------------"
 & "------------------\n% \"skip_lib\" is called when the compiler decides "
 & "it doesn\'t need to\n% call \"make_lib\", but it wants to discover the "
 & "names of the derived\n% files that should be deleted or shipped.\n\npro"
 & "c skip_lib (lib, shared) is\n  local lib_so   = format (\"lib%s.so\", l"
 & "ib)\n  local lib_sox  = format (\"lib%s.so.5\", lib)\n\n  if shared\n  "
 & "  % make sure the shared library stuff gets installed properly\n    ins"
 & "tall_derived (lib_sox)\n    install_derived (lib_so)\n    install_link_"
 & "to_derived (lib_sox, LIB_INSTALL)\n    install_link_to_derived (lib_so,"
 & " LIB_INSTALL)\n  else\n    delete_file (lib_so)\n    delete_file (lib_s"
 & "ox)\n  end\n\n  return 0\nend\n\n%-------------------------------------"
 & "------------------------------ linker ---\n% \"m3_link\" is called to p"
 & "roduce a final executable.\n\nproc m3_link (prog, options, objects, imp"
 & "orted_libs, shared) is\n  local args = []\n  if M3_PROFILING args += \""
 & "-pg\" end\n  args += [ \"-m32\", \"-o\", prog, \"-fPIC\", options, obje"
 & "cts, imported_libs ]\n  if shared\n    retu";

CONST E0_6 = 
   "rn try_exec (\"@\" & SYSTEM_CC, args)\n  else\n    return try_exec (\"@"
 & "\" & SYSTEM_CC, \"-Xlinker\", \"-Bstatic\",  args)\n    %%% -- see M3_N"
 & "EED_STANDALONE_LINKS  below\n    %%%return try_exec (\"@\" & SYSTEM_CC,"
 & " args)\n  end\nend\n\n%------------------------------------------------"
 & "-------------------\n% \"skip_link\" is called when the compiler decide"
 & "s it doesn\'t need to\n% call \"m3_link\", but it wants to discover the"
 & " names of the derived\n% files that should be deleted or shipped.\n\npr"
 & "oc skip_link (prog, shared) is\n  return 0\nend\n\n%-------------------"
 & "----------------------------------------- misc. options ---\n% Note, mo"
 & "st of these options can be set from the command line.  Otherwise,\n% th"
 & "ey can be set \"permanently\" here in the config file or in as needed\n"
 & "% in user\'s m3makefiles.\n\nM3_FRONT_FLAGS = [ ]\n% --- internal confi"
 & "guration options passed directly to the Modula-3 front-end\n\nM3_OPTION"
 & "S = [ ]\n% --- user options passed directly to the Modula-3 front-end\n"
 & "\n% M3_KEEP_FILES = TRUE\n% --- keep intermediate and temporary files\n"
 & "\n% M3_WINDOWS_GUI = TRUE\n% --- generate a Windows GUI subsystem progr"
 & "am instead of a console one.\n\n% M3_COVERAGE = TRUE\n% --- compile & l"
 & "ink with coverage options\n\nM3_COVERAGE_LIB = LIB_USE & \"/report_cove"
 & "rage.o\"\n% --- library linked in programs compiled with \"-Z\" coverag"
 & "e option\n\nM3_SPLIT_LIBNAMES = TRUE\n% --- split library names and pas"
 & "s -L/-l arguments to the linker\n\nM3_SHARED_LIB_ARG = \"-Wl,-R\"\n% --"
 & "- pass \"-R\" flags to the linker too...\n\n% M3_BOOTSTRAP = TRUE\n% --"
 & "- generate bootstrap code (assembly) instead of finaly object code\n\n%"
 & " M3_COMPILE_ONCE = TRUE\n% --- don\'t recompile code to improve opaque "
 & "object references\n\n% SYS_HAS_LOADER = TRUE\n% --- generate a loader i"
 & "nfo file with objects, libraries and timestamps\n\n% M3_SKIP_LINK = TRU"
 & "E\n% --- skip the final link for programs, presumably to use the loader"
 & " instead\n\n% M3_MAIN_IN_C = TRUE\n% --- generate the Modula-3 main pro"
 & "gram as C code\n\nX11_WITH_SHARED_MEM = TRUE\n% --- X11 libraries inclu"
 & "de the shared memory extension";

CONST E0_7 = 
   "s (XShm...)\n\n%M3_NEED_STANDALONE_LINKS = TRUE\n% --- linker is broken"
 & " and we need to build a directory of symbolic\n%     links pointing to "
 & "the non-shared libraries.\n\n%-----------------------------------------"
 & "--------------------------- emacs ---\n% If you have emacs and want to "
 & "compile \".el\" files to \".elc\" files,\n% fill in the function below."
 & "  Otherwise, comment out or delete the\n% entire function.  Note, the d"
 & "istributed code assumes gnuemacs version 19\n% or later.\n\nreadonly pr"
 & "oc emacs_compile (el) is\n  exec (\"emacs -batch -f batch-byte-compile\""
 & ", el)\nend\n\n%--------------------------------------------------------"
 & "----- GNU variants ---\n% The two large pieces of GNU software used by "
 & "the Modula-3 system\n% gcc(=m3cc) and gdb(=m3gdb) often require slightl"
 & "y different C compilers\n% or flags.  They are specified here.  Note th"
 & "at they may be overridden\n% from the m3build command line.\n%\n% To us"
 & "e the GNU defaults for CC and CFLAGS, specify \"*\".\n%\n\nGNU_CC     ="
 & " \"gcc\"\nGNU_CFLAGS = \"-O\"\nGNU_MAKE   = \"make\"\n";


BEGIN
END Setup.
